--- DatabaseMetaData.java.orig	Fri Feb 16 19:45:00 2001
+++ DatabaseMetaData.java	Thu Nov 22 15:18:34 2001
@@ -1932,8 +1932,18 @@
 
 	tuple[7] = null;	// Buffer length
 
-	tuple[8] = "0".getBytes();	// Decimal Digits - how to get this?
-	tuple[9] = "10".getBytes();	// Num Prec Radix - assume decimal
+
+        if (typname.equals("numeric")) {
+            int atttypmod = r.getInt(8);
+	    int digits = ((atttypmod - VARHDRSZ)>>16) & 0xffff;
+	    int radix = (atttypmod - VARHDRSZ) & 0xffff;
+            tuple[8] = Integer.toString(digits).getBytes();  // Decimal Digits
+            tuple[9] = Integer.toString(radix).getBytes();   // Num Prec Radix - assume decimal
+        }else{
+            tuple[8] = "0".getBytes();       // Decimal Digits - how to get this? 
+            tuple[9] = "0".getBytes();       // Num Prec Radix - assume decimal
+        } 	    	    		    	    	    	
+
 
 	// tuple[10] is below
 	// tuple[11] is above
